#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <time.h>

/* ML - Software 1992/1995 
   Testprogramm fr Farbeinstellungen
   Farbanteil wird ber Zahlenangaben gesteuert */

/* Freigabe-Nr. 1A-01 C 1996 */
/* Freeware, Vertrieb auf allen Wegen gestattet */
/* Kann zu eigenen Weiterentwicklungen benutzt werden */
/* Bitte keine (C)-Angaben entfernen */

int f_tab[32][3]=
	{
	{100,100,190},   //grau
	{100,100,180},   //graublau hell
	{90,90,170},
	{80,80,160},
	{70,70,160},     //graublau, dunkel
	{160,60,160},    // helles blaugrn
	{160,55,160},
	{160,50,160},
	{160,45,160},
	{160,40,160},     // ...
	{160,35,160},     // gemischt nach :
	{160,30,160},     // ...
	{160,25,160},
	{160,20,160},
	{160,15,160},
	{160,10,160},    // Normal-violett
	};
	// Klarnamen nur zur eigenen Orientierung eingefgt


int main(void)
{
   /* Treiber und Mode fr die Untersttzung der */
   /* 'setrgbpalette'-Funktion auswhlen.        */
   int gdriver = VGA, gmode = VGAHI, errorcode;
   struct palettetype pal;
   int i, f, ht, y, xmax;


   char c;

   /* Grafik und lokale Variablen initialisieren */
   initgraph(&gdriver, &gmode, "");

   /* Ergebnis der Initialisierung feststellen */
   errorcode = graphresult();
   if (errorcode != grOk)  /* Fehler aufgetreten */
   {
	  printf("Grafik-Error: %s\n", grapherrormsg(errorcode));
	  printf("Beliebige Taste drcken, um fortzufahren:");

	  getch();
	  exit(1); /* Abbruch mit Error-Code */
   }

   /* Palette holen */
   getpalette(&pal);

   /* Grauwert-Skala erstellen ... */
   do
   { ht = getmaxy() / 16;
     xmax = getmaxx();
     y = 0;
     f = 0;

     for (i=0; i<pal.size; i++)
      {
       setrgbpalette(pal.colors[i], f_tab[f][0], f_tab[f][1], f_tab[f][2]);
       setfillstyle(SOLID_FILL, i);
       bar(0, y, xmax, y+ht);
       y += ht;
       f++;
      }
      fflush(stdin);
      c=getch();
    } while(c != 27);
   /* .. und anzeigen */

   /* clean up */
   getch();
   closegraph();
   return 0;
}

